package java.awt;
import java.awt.peer.*;

public class Canvas extends Component {
    public Canvas() { }

    public Canvas(GraphicsConfiguration graphicsConfiguration) {
	/* setting a field of the base class like this might seem
           ugly, but it's the only way since the Component API does
           not provide a way to set this. */
	config = graphicsConfiguration;
    }
    public void addNotify() {
	if (peer == null) {
	    // See Frame.java for comment on synchronization
	    synchronized (this) {
		ComponentPeer peer = getToolkit().createCanvas(this);
		setPeer(peer);
	    }
	}
	super.addNotify();
    }

    /** Override this to create components with custom painting.
	Defaults to filling the component with the background color. */

    
    public void paint(Graphics gfx) {
	/*
	  This implementation doesn't make much sense since the
	  filling of background color is guaranteed for heavyweight
	  components such as this. I won't fuzz, since paint() is
	  usually overridden anyway.
	*/

	gfx.setColor(getBackground());
	Dimension size = getSize();
	gfx.fillRect(0, 0, size.width, size.height);
    }
}
