package java.awt;

import java.util.EmptyStackException;
import java.lang.reflect.InvocationTargetException;
import java.awt.event.*;

/*
  The Java APIs suck. I have no idea about how the queue push/pop mechanism
  is supposed to work. Here are some guesses...

  ,--- push new queues here
  |
  |    ,--- next event
  |    |      
  |    |      ,--- new events are posted here
  |    |      |
  V    V      V
     +---------+ next     prev +--------------+
  |--| 1 2 3   |---------------|              |-- ... --|
     +---------+               +--------------+

     requests are forwarded to next as long as next!=null.

     A queue that cannot post new events, can 
*/
public class EventQueue {

    EventQueue next;
    EventQueue previous;

    public EventQueue() {}

    public void postEvent(AWTEvent newEvent) {
	if (next != null) {
	    // ...flush own events?...
	    next.postEvent(newEvent);
	    return;
	}

	
	throw new UnsupportedOperationException("not implemented yet");
	/* outline:
	AWTEvent existing = peekEvent(evt.getId());
	Object src = evt.getSource();
	if ((existing != null) &&
	    (existing.getSource() == src) &&
	    (src instanceof Component)) {
	    AWTEvent combined =
		((Component) src).coalesceEvents(existing, newEvent);
	    if (comnined != null) {
		cancelEvent(existing);
		newEvent = combined;
	    }
	}
	
	// ... do real posting ...
	*/
	
    }

    public AWTEvent getNextEvent()
	throws InterruptedException {
	if (next != null) return getNextEvent();
	
	throw new UnsupportedOperationException("not implemented yet");
    }

    public AWTEvent peekEvent() {
	throw new UnsupportedOperationException("not implemented yet");
    }

    public AWTEvent peekEvent(int id) {
	throw new UnsupportedOperationException("not implemented yet");
    }

    protected void dispatchEvent(AWTEvent newEvent) {
	Object source = newEvent.getSource();
	if (source instanceof Component) {
	    Component component = (Component) source;
	    component.dispatchEvent(newEvent);
	    return;
	}

	/*
	if (source instanceof MenuComponent) {
	    MenuComponent menuComponent = (MenuComponent) source;
	    menuComponent.dispatchEvent(newEvent);
	    return;
	}
	*/


	/* FIXME: What the hell is an ActiveEvent?

	if (newEvent instanceof ActiveEvent) {
	    ActiveEvent activeEvent = (ActiveEvent) newEvent;
	    activeEvent.dispatch();
	    
	}
	*/

	// Ignore unrecognized events...
	return;
    }

    private AWTEvent nonblockingGetNextEvent() {
	if (peekEvent() == null) return null;
	try {
	    return getNextEvent();
	} catch (InterruptedException ie) {
	    // FIXME: what now?
	    throw new RuntimeException(ie.toString());
	}
    }

    public void push(EventQueue newEventQueue) {
	if (next != null) {
	    next.push(newEventQueue);
	    return;
	}
	
	// drain this event queue into the next.
	while (peekEvent() != null) {
	    newEventQueue.postEvent(nonblockingGetNextEvent());
	}
	
	// couple queues
	next = newEventQueue;
	newEventQueue.previous = this;
    }

    protected void pop() throws EmptyStackException {
	if (previous == null) {
	    throw new EmptyStackException();
	}

	// FIXME: some locking is needed here...

	// decouple queues
	EventQueue prev = previous;
	previous.next = null;
	previous = null;
	
	// push back events this event queue into the previous queue.
	while (peekEvent() != null) {
	    prev.postEvent(nonblockingGetNextEvent());
	}
    }

    public static boolean isDispatchThread() {
	// should perhaps be...
	//Toolkit.getDefaultToolkit().getSystemEventQueue().isDispatchThreadImpl();

	throw new UnsupportedOperationException("not implemented yet");
    }
    
    private boolean isDispatchThreadImpl() {
	if (next != null) return next.isDispatchThread();
	throw new UnsupportedOperationException("not implemented yet");
    }
    


    public static void invokeLater(Runnable runnable) {
	throw new UnsupportedOperationException("not implemented yet");
	
    }
    

    public static void invokeAndWait(Runnable runnable)
	throws InterruptedException, InvocationTargetException {
	throw new UnsupportedOperationException("not implemented yet");
    }
    

}
