package no.rwr.awt.x;

import java.awt.*;
import java.awt.peer.*;
import java.awt.image.*;
import no.rwr.x.WMSizeHints;
import no.rwr.x.WindowAttributes;
import no.rwr.x.Display;
import no.rwr.x.Visual;
import no.rwr.x.Screen;



/** FIXME: a lot of the code here should be moved down to XWindowPeer. */

public class XFramePeer extends XCanvasPeer implements FramePeer {

    public XFramePeer(Frame frame) {
	super(frame);
    }

    /** Find parent window for toplevel window, ie. root window of
	selected screen. Bounds are not changed. */
    no.rwr.x.Window locateParentWindow(Rectangle bounds) {
	Screen screen = config.getVisual().getScreen();
	return screen.getRootWindow();
    }
	
    void initWindowProperties() {
	Frame frame = (Frame) component;

	WMSizeHints sizeHints = new WMSizeHints();
	if (frame.isResizable()) {
	    Dimension minSize = frame.getMinimumSize();
	    sizeHints.setMinSize(minSize.width, minSize.height);
	    
	    // getMaximumSize() not implemented in Component yet
	    //Dimension maxSize = frame.getMaximumSize();
	    //sizeHints.setMaxSize(maxSize.width, maxSize.height);
	} else {
	    // lock resizing to current bounds
	    Dimension size = frame.getSize();
	    sizeHints.setMinSize(size.width, size.height);
	    sizeHints.setMaxSize(size.width, size.height);
	}
	sizeHints.applyNormalHints(window);
	
	String title = frame.getTitle();
	if (!title.equals("")) setTitle(title);
    }



    // Implementing ContainerPeer:

    static final Insets INSETS_0_PROTOTYPE = new Insets(0, 0, 0, 0);
    public Insets getInsets() {
	return (Insets) INSETS_0_PROTOTYPE.clone();
    }

    // Implementing FramePeer:

    public void setTitle(String title) {
	synchronized (window.getDisplay()) {
	    // Oh, what a nice implementation :-)
	    window.setProperty("WM_NAME", "STRING", title);

	    ensureFlush();
	}
    }
}
