package no.rwr.x;
import gnu.gcj.RawData;

/** Base class for interpreters of specific X event types.

    For methods concerning all X events, see XAnyEven.
 */

public class XEvent {

    public XEvent(XAnyEvent event) {
	this.event = event;
    }

    public XEvent(int type, Display display) {
	this(new XAnyEvent(display));
	event.setType(type);
    }

    XAnyEvent event;

    public XAnyEvent getXAnyEvent() {
	return event;
    }

    public String toString() {
	if (event == null) return super.toString();
	return event.toString();
    }
}
